- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes

# MudboxCurve Class Reference

Search for all occurrences

## Detailed Description

Definition at line 86 of file curve.h.

`#include <curve.h>`

Inheritance diagram for MudboxCurve:
[legend]

List of all members.

## Public Types
enum | CurveType { CT_3D = 0, CT_2D }
| Curve type. Used to determine if curve is treated as a ViewCurve (2D) or a regular 3D curve. More...
## Public Member Functions
| MudboxCurve ()
virtual | ~MudboxCurve ()
virtual int | AddPoint (const CurvePoint &pt)
| Add 3D world space point to end of point list.
virtual bool | SetPoint (int index, const CurvePoint &pt)
| Replaces existing point to the values passed in.
virtual bool | SetPoint (int index, const Vector &pt)
| Replaces existing point to the values passed in.
virtual const CurvePoint & | Point (int index) const
| Returns the 3D world space point from specified index.
virtual Vector | WorldPosition (int iIndex) const
| Returns the world space position of the specified point.
virtual int | PointCount () const
| Returns the number of points.
virtual bool | Point (int index, CurvePoint &point)
| Sets the input to the 3D world space point at index.
virtual const QList< CurvePoint > & | Points ()
| Returns the array of points.
virtual bool | InsertPoint (int before, const CurvePoint &pt)
| Insert 3D world space point into point list.
virtual bool | RemovePoint (int index)
| Removes 3D world space point at index.
virtual void | Serialize (Stream &s)
| Serialize the node.
virtual const AxisAlignedBoundingBox & | BoundingBox ()
| Return world space bounding box.
virtual void | CopyTo (Node *pNode) const
| Copies Curve into another Curve (pNode must be Curve type)
virtual bool | IsConstrainedToSurface (void) const
| TODO.
virtual void | CreateSpline (float fSmoothness)
| Creates a NURBS curve.
virtual void | BeginEdit ()
| Pauses any updating of the spline or any other automatic updating while adding points.
virtual void | EndEdit ()
| Updates & resumes any auto updating.
virtual NURBSCurve * | Spline () const
| Returns the internal spline representation if it exists.
virtual bool | IsSpline (void) const
| Returns true if a NURBS representation exists for this Curve.
virtual void | ProjectPoint (const Vector &vPoint, Vector &vResult) const
| Project a point onto the curve.
virtual void | SetCurveType (enum CurveType ct)
| Sets the curve type. Can be 3D or 2D. At this time, only affects how curve is edited and rendered.
virtual enum CurveType | CurveType () const
| Returns the Curve type.
virtual NURBSCurve * | FalloffCurve ()
| Returns the fall off curve used for certain operations on this Curve.
## Protected Attributes
QList< CurvePoint > | m_vPoints
| Using QList for storage.
enum CurveType | m_eCurveType

## Member Enumeration Documentation

enum CurveType

Search for all occurrences

Curve type. Used to determine if curve is treated as a ViewCurve (2D) or a regular 3D curve.

Enumerator:

  CT_3D | Search for all occurrences
  CT_2D | Search for all occurrences

Definition at line 164 of file curve.h.

        {
            CT_3D = 0,
            CT_2D,
        };

## Constructor & Destructor Documentation

MudboxCurve | ( |  | ) |

virtual ~MudboxCurve | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual int AddPoint | ( | const CurvePoint & | pt | ) | `[virtual]`

Search for all occurrences

Add 3D world space point to end of point list.

Returns index of added point.

virtual bool SetPoint | ( | int | index,
|  | const CurvePoint & | pt
| ) |  | `[virtual]`

Search for all occurrences

Replaces existing point to the values passed in.

Returns true on success, false on failure.

virtual bool SetPoint | ( | int | index,
|  | const Vector & | pt
| ) |  | `[virtual]`

Search for all occurrences

Replaces existing point to the values passed in.

Returns true on success, false on failure.

virtual const CurvePoint& Point | ( | int | index | ) | const `[virtual]`

Search for all occurrences

Returns the 3D world space point from specified index.

No fail condition.

virtual Vector WorldPosition | ( | int | iIndex | ) | const `[virtual]`

Search for all occurrences

Returns the world space position of the specified point.

virtual int PointCount | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns the number of points.

virtual bool Point | ( | int | index,
|  | CurvePoint & | point
| ) |  | `[virtual]`

Search for all occurrences

Sets the input to the 3D world space point at index.

Returns true if succeeded or false if failed.

virtual const QList<CurvePoint>& Points | ( |  | ) | `[virtual]`

Search for all occurrences

Returns the array of points.

virtual bool InsertPoint | ( | int | before,
|  | const CurvePoint & | pt
| ) |  | `[virtual]`

Search for all occurrences

Insert 3D world space point into point list.

Returns true if successful, otherwise false.

virtual bool RemovePoint | ( | int | index | ) | `[virtual]`

Search for all occurrences

Removes 3D world space point at index.

Returns true if successful, otherwise false.

virtual void Serialize | ( | Stream & | s | ) | `[virtual]`

Search for all occurrences

Serialize the node.

Reimplemented from CurveBase.

virtual const AxisAlignedBoundingBox& BoundingBox | ( |  | ) | `[virtual]`

Search for all occurrences

Return world space bounding box.

Reimplemented from CurveBase.

virtual void CopyTo | ( | Node * | pNode | ) | const `[virtual]`

Search for all occurrences

Copies Curve into another Curve (pNode must be Curve type)

Reimplemented from CurveBase.

virtual bool IsConstrainedToSurface | ( | void |  | ) | const `[virtual]`

Search for all occurrences

TODO.

virtual void CreateSpline | ( | float | fSmoothness | ) | `[virtual]`

Search for all occurrences

Creates a NURBS curve.

virtual void BeginEdit | ( |  | ) | `[virtual]`

Search for all occurrences

Pauses any updating of the spline or any other automatic updating while adding points.

virtual void EndEdit | ( |  | ) | `[virtual]`

Search for all occurrences

Updates & resumes any auto updating.

virtual NURBSCurve* Spline | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns the internal spline representation if it exists.

Returns NULL if spline does not exist. Makes IsSpline somewhat redundant.

virtual bool IsSpline | ( | void |  | ) | const `[virtual]`

Search for all occurrences

Returns true if a NURBS representation exists for this Curve.

virtual void ProjectPoint | ( | const Vector & | vPoint,
|  | Vector & | vResult
| ) |  | const `[virtual]`

Search for all occurrences

Project a point onto the curve.

virtual void SetCurveType | ( | enum CurveType | ct | ) | `[virtual]`

Search for all occurrences

Sets the curve type. Can be 3D or 2D. At this time, only affects how curve is edited and rendered.

virtual enum CurveType CurveType | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns the Curve type.

virtual NURBSCurve* FalloffCurve | ( |  | ) | `[virtual]`

Search for all occurrences

Returns the fall off curve used for certain operations on this Curve.

## Member Data Documentation

QList<CurvePoint> m_vPoints `[protected]`

Search for all occurrences

Using QList for storage.

Ultimately not the fastest method of storing but allows faster insert & deletions of points.

Definition at line 182 of file curve.h.

enum CurveType m_eCurveType `[protected]`

Search for all occurrences

Definition at line 183 of file curve.h.

The documentation for this class was generated from the following file:

- Mudbox/curve.h

MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve
MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve MudboxCurve